<?php

namespace App\Service;

use App\Entity\Counter;
use Doctrine\ORM\EntityManagerInterface;

class CounterManager
{
    public function __construct(
        protected EntityManagerInterface $em
    )
    {

    }

    public function init(string $ttl, ?string $name = null): Counter
    {
        $counter = new Counter();
        $counter->setName($name);
        $counter->setTimeTolive($ttl);
        $counter->setState('ready');

        $this->em->persist($counter);
        $this->em->flush();

        return $counter;
    }

    public function start(Counter $counter): Counter
    {
        $counter->setStartTime(new \DateTimeImmutable('now'));
        $counter->setEndTime($counter->getStartTime()->add(new \DateInterval($counter->getTimeTolive())));

        $counter->setState('started');

        $this->em->flush();
        return $counter;
    }
}